#include "allegro.h"
#include "allegro_color.h"
#include "enemy.h"
#include "mappyal.h"
#include "sprite.h"
#include "dome.h"
#include<math.h>

ENEMY::ENEMY()
{
	spr = NULL;
	type = 0;
	bImage = NULL;
	hp = 1;
}

ENEMY::~ENEMY()
{

}

void ENEMY::load(DOME *dDomes[MAX_DOMES])
{
	spr = new SPRITE;
	if(type == 0)
	{
		spr->load("alien.bmp", 128, 128, 5);		
		spr->xspeed = 3;
		spr->yspeed = 3;
		spr->framedelay = 4;		
		power = 1;
		hitcount = 0;
		hitdelay = 50;
		hp = 10;
		max_hp = 10;
		bImage = create_bitmap(128, 128);
	}

	locate();
	find_dome(dDomes);
	spr->alive = true;
	

}

void ENEMY::locate()
{
	int pick, shift = 0;
	bool picked_y;

	

	//pick a y or a x	
	pick = rand() % 10 + 1;
	//allegro_message("%d", pick);
	if(pick <= 5)
		picked_y = true;
	else
		picked_y = false;

	//pick an axis
	pick = rand() % 10 + 1;
	if(pick <= 5)
	{
		shift = spr->height * -1;
		if(picked_y == true)
			spr->x = 0;
		else
			spr->y = 0;
	}	
	else
	{
		shift = spr->height;
		if(picked_y == true)
			spr->x = mapblockwidth * mapwidth;
		else
			spr->y = mapblockheight * mapheight;
	}

	//pick a random 
	if(picked_y == true)
		spr->y = rand() % (mapblockheight * mapheight);
	else
		spr->x = rand() % (mapblockwidth * mapwidth);

	//allegro_message("Enemy created!  %d %d", spr->x, spr->y);

	//move off screen
	if(picked_y == true)
		spr->y += shift;
	else
		spr->x += shift;

	x = spr->x;
	y = spr->y;
	//x = 186;
	//y = 0;
	//allegro_message("Enemy created!  %f %f", x, y);	
}

void ENEMY::attack(DOME *dDome)
{
	if(abs(system_time - hitcount) > hitdelay)	
	{
		dDome->hp -= power;
		hitcount = system_time;		
	}
	
}

void ENEMY::update(DOME *dDomes[MAX_DOMES])
{	
	int n;
	float oldpx, oldpy;
	bool found = false;

	oldpx = x;
	oldpy = y;
	y += float(spr->yspeed) * fixtof(fixcos(itofix((int)angle/1.40625)));
	x -= float(spr->xspeed) * fixtof(fixsin(itofix((int)angle/1.40625)));	

	for(n = 0; n < MAX_DOMES; n++)
	{
		if(dDomes[n]->spr->alive)
		{
			if(x > dDomes[n]->x && x < dDomes[n]->x + dDomes[n]->spr->width
				 && y > dDomes[n]->y && y < dDomes[n]->y + dDomes[n]->spr->height)
				 found = true;
			if(x + spr->width > dDomes[n]->x && x + spr->width < dDomes[n]->x + dDomes[n]->spr->width
				 && y > dDomes[n]->y && y < dDomes[n]->y + dDomes[n]->spr->height)
				 found = true;
			if(x > dDomes[n]->x && x < dDomes[n]->x + dDomes[n]->spr->width
				 && y + spr->height > dDomes[n]->y && y + spr->height < dDomes[n]->y + dDomes[n]->spr->height)
				 found = true;
			if(x + spr->width > dDomes[n]->x && x + spr->width < dDomes[n]->x + dDomes[n]->spr->width
				 && y + spr->height > dDomes[n]->y && y + spr->height < dDomes[n]->y + dDomes[n]->spr->height)
				 found = true;

			if(found == true)
			{
				x = oldpx;
				y = oldpy;
				attack(dDomes[n]);
				if(dDomes[n]->hp <= 0)
					dDomes[n]->spr->alive = false;
				find_dome(dDomes);
			}
		}
	}
	spr->animate();	
}

void ENEMY::hit()
{
	// Do a cool flash animation here if you have time.

	hp--;
	// Killed an enemy, good job!
	if(hp <= 0)
	{
		x = 0;
		y = 0;
		spr->alive = false;
		wait = rand() % 2000 + system_time;
	}
}

void ENEMY::draw_status(BITMAP *desc, int xoffset, int yoffset)
{
	if(hp > 0)
	{		
		rectfill(desc, x - xoffset, y - 10 - yoffset, x + spr->width - xoffset, y - 0 - yoffset, BLACK);
		rectfill(desc, x - xoffset, y - 10 - yoffset, x + (spr->width * (float(hp) / float(max_hp))) - xoffset, y - 0 - yoffset, GREEN);
		rect(desc, x  - xoffset, y - 10 - yoffset, x + spr->width  - xoffset, y - 0 - yoffset, WHITE);
	}

}


void ENEMY::find_dome(DOME *dDomes[MAX_DOMES])
{
	int n = -1, distance = 0, minimum = 9999999, select = 0;

	for(n = 0; n< MAX_DOMES; n++)
	{
		if(dDomes[n]->spr->alive)
		{
			distance = dist(x, y, dDomes[n]->x, dDomes[n]->y);
			if(distance < minimum)
			{
				minimum = distance;
				select = n;
			}
		}
	}
	if(n == -1)
		return;

	//assume the dome is at 640, 480
	if(y > dDomes[select]->y )
	{
	if(x > dDomes[select]->x)
		angle = 180 - (fixtoi(fixacos(ftofix(float(abs(y - dDomes[select]->y)) / float(dist(x, y, dDomes[select]->x, dDomes[select]->y))))) / 0.71111111) + 1;
	else
		angle = 180 +  (fixtoi(fixacos(ftofix(float(abs(y - dDomes[select]->y)) / float(dist(x, y, dDomes[select]->x, dDomes[select]->y))))) / 0.71111111) + 1;
	}
	else
	{
	if(x > 640)
		angle = (fixtoi(fixacos(ftofix(float(abs(y - dDomes[select]->y)) / float(dist(x, y, dDomes[select]->x, dDomes[select]->y))))) / 0.71111111) + 1;
	else
		angle = 360 - (fixtoi(fixacos(ftofix(float(abs(y - dDomes[select]->y)) / float(dist(x, y, dDomes[select]->x, dDomes[select]->y))))) / 0.71111111) + 1;
	}		
}

float ENEMY::dist(float x1, float y1, float x2, float y2)
{
	return sqrt(pow((x2 - x1), 2) + pow((y2 - y1), 2));
}


