#ifndef _ENEMY_H_
#define _ENEMY_H_

#include "sprite.h"
#include "game.h"
#include "dome.h"

class ENEMY
{
public:
	SPRITE *spr;
	BITMAP *bImage;
	int type;
	int angle;
	float x;
	float y;
	int wait;
	int hitcount, hitdelay;
	int power;
	int hp;	
	int max_hp;

	ENEMY();
	~ENEMY();

	void load(DOME *dDomes[MAX_DOMES]);
	void locate();
	void attack(DOME *dDome);
	void find_dome(DOME *dDomes[MAX_DOMES]);
	void update(DOME *dDomes[MAX_DOMES]);	
	float dist(float x1, float y1, float x2, float y2); //just copied this from overworld
	void hit();
	void draw_status(BITMAP *desc, int xoffset, int yoffset);
	

};

#endif /* End of _ENEMY_H_ */