#include "allegro.h"
#include "mappyal.h"
#include "game.h"

BITMAP *buffer;

volatile int counter;
volatile int ticks;
volatile int framerate;
volatile int system_time;



void MappyLoad(char *path)
{
	if(MapLoad(path))
	{
		set_gfx_mode(GFX_TEXT, 0, 0, 0, 0);
		allegro_message("Cannot find MAP file:  %s", path);
		exit(0);
	}
}

void DrawMap(BITMAP *bDesc, int &x, int &y)
{
	BITMAP *bLayers;

	
	if(x < 0) x = 0;
	if(x > (mapwidth * mapblockwidth - GFX_W))
		x = mapwidth * mapblockwidth - GFX_W;
	if(y < 0)
		y = 0;
	if(y > (mapheight * mapblockheight - GFX_H))
		y = mapheight * mapblockheight - GFX_H;

	MapChangeLayer(0);
	MapDrawBG(bDesc, x, y, 0, 0, GFX_W - 1, GFX_H - 1);
	MapDrawFG(bDesc, x, y, 0, 0, GFX_W - 1, GFX_H - 1, 0);

	bLayers = create_bitmap(bDesc->w, bDesc->h);
	MapChangeLayer(1);
	MapDrawBG(bLayers, x, y, 0, 0, GFX_W - 1, GFX_H - 1);
	MapDrawFG(bLayers, x, y, 0, 0, GFX_W - 1, GFX_H - 1, 0);

	draw_sprite(bDesc, bLayers, 0, 0);

	destroy_bitmap(bLayers);
	
}
