#include "allegro.h"
#include "allegro_color.h"
#include "overworld.h"
#include "game.h"
#include "mappyal.h"
#include "sprite.h"
#include "bullet.h"
#include "alogg.h"
#include <math.h>
#include <string.h>

//Only way I could get this to work was to stick a globabl right here.  It sucks,
//but I'm too concerned about perfect efficiency at the moment...
BLKSTR *current_block;

OVERWORLD::OVERWORLD()
{
	unit = NULL;
	mapxoff = 0;
	mapyoff = 0;
	bullet_count = 0;
	block_x = 0;
	block_y = 0;
	gun_type = 0;
}

OVERWORLD::~OVERWORLD()
{

}

void OVERWORLD::main_loop(char *path)
{	
	int n = 0;
	FILE *fOgg;
	ALOGG_OGG *music;
	char *data;
	int len;
	bool quit = false;
	
	len = (int)file_size("Airship.ogg");
	data = new char[len];
    fOgg = fopen("Airship.ogg", "r");
	fread(data, 1, len, fOgg);
	if(!fOgg) allegro_message("uh oh...");	
	
	music = alogg_create_ogg_from_buffer(data, len);
	if(music == NULL)
		allegro_message("death");

	alogg_play_ex_ogg(music, 65536, 255, 127, 1000, 1);
	alogg_start_autopoll_ogg(music, 25);

	MappyLoad(path);	
	
	unit = new CART;
	unit->load(0);	
	
	for(n = 0; n< MAX_DOMES; n++)
		dDomes[n] = new DOME;

	if(strcmp(path, "level1.fmp") == 0)
	{
		unit->x = 160;
		unit->y = 128;	
		block_x = 5;
		block_y = 4;
		dDomes[0]->load(288, 160);		
	}
	else
	{
		unit->x = 320;
		unit->y = 352;	
		block_x = 10;
		block_y = 11;
		dDomes[0]->load(640, 480);		
	}
	
		
	x_stamp = unit->x + (unit->mobile->width/2);
	y_stamp = unit->y + (unit->mobile->height/2);
	current_y = unit->y;
	current_block = MapGetBlock((unit->x)/mapblockwidth, (unit->y) / mapblockheight);
	//unit->xspeed = 2;
	//unit->yspeed = 2;
	unit->engine_speed = 0.0;
	unit->max_speed = 10;
	for(n=0; n<MAX_BULLETS; n++)
	{
		bBullets[n] = new BULLET;
		bBullets[n]->load(0, 0, 0);
		bBullets[n]->sBullet->alive = false;
	}

	system_time = 0;

	
	for(n = 0; n< MAX_ENEMIES; n++)
	{
		eEnemies[n] = new ENEMY;
		eEnemies[n]->load(dDomes);
		eEnemies[n]->wait = rand() % 1000;
		eEnemies[n]->spr->alive = false;
	}

	
	

	bGUI = load_bitmap("gui.bmp", NULL);
	bFace = load_bitmap("face.bmp", NULL);
	score = 0;	
	game_time = 0;
	//Main Overworld Loop
	while(!key[KEY_ESC] && quit == false)
	{
		//Input 
		input();		
		UpdateBullets();
		UpdateEnemies();	
		if(UpdateDomes() == false)
		{
			quit = true;
			GameOver();
		}
		UpdateScore();
		draw();

		ticks++;
	}
	
	destroy_bitmap(bGUI);
	MapFreeMem();
	for(n = 0; n < MAX_BULLETS; n++)
		delete bBullets[n];
	delete unit;
}

void OVERWORLD::UpdateScore()
{
	int n;
	if(abs(system_time - score_delay) > 50)
	{
		game_time++;
		for(n = 0; n < MAX_DOMES; n++)
		{
			if(dDomes[n]->spr->alive)
				score++;
		}

		score_delay = system_time;
	}
}

void OVERWORLD::draw()
{
	int n = 0;
	DrawMap(buffer, mapxoff, mapyoff);
	for(n = 0; n < MAX_DOMES; n++)
	{
		if(dDomes[n]->spr->alive)
		{
			dDomes[n]->draw_status(buffer, mapxoff, mapyoff);
			draw_sprite(buffer, dDomes[n]->spr->bImage, dDomes[n]->x - mapxoff, dDomes[n]->y - mapyoff);
		}
	}
	
	for(n = 0; n < MAX_BULLETS; n++)
	{
		if(bBullets[n]->sBullet->alive)
			draw_sprite(buffer, bBullets[n]->sBullet->bImage, bBullets[n]->sBullet->x - mapxoff, bBullets[n]->sBullet->y - mapyoff);

	}
	unit->draw();
	draw_sprite(buffer, unit->bImage, unit->x - mapxoff, unit->y - mapyoff);
	for(n = 0; n < MAX_ENEMIES; n++)
	{
		if(eEnemies[n]->spr->alive)
		{
			eEnemies[n]->draw_status(buffer, mapxoff, mapyoff);
			rotate_sprite(buffer, eEnemies[n]->spr->bImage, eEnemies[n]->x - mapxoff, eEnemies[n]->y - mapyoff, itofix((int)(eEnemies[n]->angle)/1.40625));	
		}
	}

	DrawGUI();
	//DrawDebug();
	draw_sprite(screen, buffer, 0, 0);
}

void OVERWORLD::DrawGUI()
{
	BITMAP *bTemp, *bText;
	bTemp = create_bitmap(bGUI->w, bGUI->h);

	clear(bTemp);
	rectfill(bTemp, 0, 0, bTemp->w, bTemp->h, MASK);
	rectfill(bTemp, 13, 390, 13 + bFace->w, 390 + bFace->h, BLACK);
	draw_sprite(bTemp, bFace, 13, 390);
	draw_sprite(bTemp, bGUI, 0, 0);

	// Framerate
	rectfill(bTemp, 118, 450, 188, 470, RED);
	line(bTemp, 118, 450, 118, 470, DARKRED);
	line(bTemp, 118, 450, 188, 450, DARKRED);
	bText = create_bitmap(70, 20);
	clear(bText);
	rectfill(bText, 0, 0, bText->w, bText->h, MASK);
    textprintf(bText, font, bText->w / 2 - 10, bText->h / 2 - 5, ORANGERED, "%d", framerate);
	draw_sprite(bTemp, bText, 118, 450);
	destroy_bitmap(bText);

	// Engine
	rectfill(bTemp, 280, 425, 360, 438, RED);
	line(bTemp, 280, 425, 280, 438, DARKRED);
	line(bTemp, 280, 425, 360, 425, DARKRED);
	bText = create_bitmap(80, 13);
	clear(bText);
	rectfill(bText, 0, 0, bText->w, bText->h, MASK);
    textprintf(bText, font, bText->w / 2 - 10, bText->h / 2 - 5, ORANGERED, "%f", unit->engine_speed);
	draw_sprite(bTemp, bText, 280, 425);
	destroy_bitmap(bText);

	// Score
	rectfill(bTemp, 280, 455, 360, 468, RED);
	line(bTemp, 280, 455, 280, 468, DARKRED);
	line(bTemp, 280, 455, 360, 455, DARKRED);
	bText = create_bitmap(80, 13);
	clear(bText);
	rectfill(bText, 0, 0, bText->w, bText->h, MASK);
    textprintf(bText, font, bText->w / 2 - 10, bText->h / 2 - 5, ORANGERED, "%d", score);
	draw_sprite(bTemp, bText, 280, 455);
	destroy_bitmap(bText);

	// Time
	rectfill(bTemp, 450, 450, 510, 470, RED);
	line(bTemp, 450, 450, 450, 470, DARKRED);
	line(bTemp, 450, 450, 510, 450, DARKRED);
	bText = create_bitmap(60, 20);
	clear(bText);
	rectfill(bText, 0, 0, bText->w, bText->h, MASK);
    textprintf(bText, font, bText->w / 2 - 10, bText->h / 2 - 5, ORANGERED, "%d", game_time);
	draw_sprite(bTemp, bText, 450, 450);
	destroy_bitmap(bText);





	draw_sprite(buffer, bTemp, 0, 0);

	destroy_bitmap(bTemp);
}

void OVERWORLD::DrawDebug()
{		
	textprintf(buffer, font, 10, 380, WHITE, "Block# (X,Y):  %d, %d", block_x, block_y);
	textprintf(buffer, font, 10, 390, WHITE, "Unit# (X,Y):  %d, %d", unit->x / mapblockwidth, unit->y / mapblockheight);
	textprintf(buffer, font, 10, 400, WHITE, "Map (X,Y):  %d, %d", mapxoff, mapyoff);
	textprintf(buffer, font, 10, 410, WHITE, "Unit (X,Y):  %d, %d", unit->x, unit->y);	
	if(unit->facing == DOWN) textprintf(buffer, font, 10, 420, WHITE, "Facing:  DOWN");
	if(unit->facing == UP) textprintf(buffer, font, 10, 420, WHITE, "Facing:  UP");
	if(unit->facing == RIGHT) textprintf(buffer, font, 10, 420, WHITE, "Facing:  RIGHT");
	if(unit->facing == LEFT) textprintf(buffer, font, 10, 420, WHITE, "Facing:  LEFT");
	textprintf(buffer, font, 10, 430, WHITE, "Framerate:  %d", framerate);
	textprintf(buffer, font, 10, 440, WHITE, "System:  %d", system_time);
	textprintf(buffer, font, 10, 440, WHITE, "Engine:  %f", unit->engine_speed);
	//textprintf(buffer, font, 10, 450, WHITE, "Enemy:  %f %f", eEnemies->x, eEnemies->y);
	
}

/************************************* COLLISIONS *******************************/
// tl = top
// tr = bottom
// bl = left
// br = right

void OVERWORLD::input()
{
	int n = 0, wait = 0;
	bool shot = false;
	// Toggle Shooting modes
	if(key[KEY_T] && !key_flag)
	{
		if(unit->MODE == 0)
			unit->MODE = 1;
		else
			unit->MODE = 0;
		key_flag = true;
	}
	if(!key[KEY_T])
		key_flag = false;

	// Handles moving the cart (it's a doozy)
	movement();

	if(key[KEY_F1])
		help_menu();

	// Turret control
	if(unit->MODE == 0)
		quick_shooting();
	else
		smooth_shooting();

	// Shooting control
	if(key[KEY_SPACE])
	{
		if(gun_type == 0) wait = 5;
		if(abs(system_time - fire_delay) > wait)
		{
			for(n = 0; n < MAX_BULLETS; n++)
			{
				if(!bBullets[n]->sBullet->alive && shot != true)
				{								
					bBullets[n]->type = gun_type;
					bBullets[n]->load(unit->angle, unit->x + unit->mobile->width/2, unit->y + unit->mobile->height/2);				
					shot = true;
					fire_delay = system_time;
				}
			}
		}
		
	}
}

void OVERWORLD::help_menu()
{
	BITMAP *bTemp = create_bitmap(screen->w, screen->h);
	clear(bTemp);
	rectfill(bTemp, 0, 0, bTemp->w, bTemp->h, MASK);	
	clear(screen);	
	textprintf(bTemp, font, 0, 0, WHITE, "------------------Help Menu-----------------");
	textprintf(bTemp, font, 0, 10, WHITE, "LEFT CONTROL - Turn on front engines");
	textprintf(bTemp, font, 0, 20, WHITE, "SHIFT or ALT - Turn on back engines");
	textprintf(bTemp, font, 0, 30, WHITE, "SPACE - Fire fire-like weapon");
	textprintf(bTemp, font, 0, 40, WHITE, "ARROW KEYS - Aim Turret");
	textprintf(bTemp, font, 0, 50, WHITE, "F1 - Help Menu");
	textprintf(bTemp, font, 0, 60, WHITE, "ESC - Exit current map and/or game");
	textprintf(bTemp, font, 0, 100, WHITE, "Object of Game");
	textprintf(bTemp, font, 0, 110, WHITE, "Kill the oncoming Balrogs before they reach the");
	textprintf(bTemp, font, 0, 120, WHITE, "domes.  You receive one point for each dome");
	textprintf(bTemp, font, 0, 130, WHITE, "still standing after every second.  Don't ");
	textprintf(bTemp, font, 0, 140, WHITE, "let the monsters win!");
	textprintf(bTemp, font, 0, 180, WHITE, "The core elements of this game are done, ");
	textprintf(bTemp, font, 0, 190, WHITE, "however, there is so much lacking, it doesn't");
	textprintf(bTemp, font, 0, 200, WHITE, "feel quite like a game, does it?  Trying to ");
	textprintf(bTemp, font, 0, 210, WHITE, "save myself, I quickly changed the gameplay 2 ");
	textprintf(bTemp, font, 0, 220, WHITE, "hours before it was time to send in the final");
	textprintf(bTemp, font, 0, 230, WHITE, "submission.  Oh well, it's not terribly bad.");
	draw_sprite(screen, bTemp, 0, 0);
	while(!key[KEY_ESC]){}
	while(key[KEY_ESC]){}

	destroy_bitmap(bTemp);
}

void OVERWORLD::GameOver()
{
	BITMAP *bTemp = create_bitmap(screen->w, screen->h);
	clear(bTemp);
	rectfill(bTemp, 0, 0, bTemp->w, bTemp->h, MASK);	
	clear(screen);		
	
	textprintf(bTemp, font, 0, 0, WHITE, "------------------Game Over-----------------");
	textprintf(bTemp, font, 0, 10, WHITE, "The Balrogs destroyed all your domes!");
	textprintf(bTemp, font, 0, 20, WHITE, "Final score:  %d", score);
	if(score < 20)
		textprintf(bTemp, font, 0, 30, WHITE, "Is that the best you can do?");
	else if(score >= 20 && score < 40)
		textprintf(bTemp, font, 0, 30, WHITE, "Not bad...");
	else if(score >= 40 && score < 60)
		textprintf(bTemp, font, 0, 30, WHITE, "Decent.");
	else if(score >= 60 && score < 80)
		textprintf(bTemp, font, 0, 30, WHITE, "Good...");
	else if(score >= 80 && score < 100)
		textprintf(bTemp, font, 0, 30, WHITE, "Rockin'!");
	else
		textprintf(bTemp, font, 0, 30, WHITE, "Man, you've been playing this buggy game way too long!");

	textprintf(bTemp, font, 0, 40, WHITE, "Time:  %d", game_time);
	textprintf(bTemp, font, 0, 50, WHITE, "Press ESC to continue");

	draw_sprite(screen, bTemp, 0, 0);
	while(!key[KEY_ESC]){}
	while(key[KEY_ESC]){}

	destroy_bitmap(bTemp);

}

void OVERWORLD::UpdateEnemies()
{
	int n;

	for(n = 0; n < MAX_ENEMIES; n++)
	{
		if(system_time > eEnemies[n]->wait && !eEnemies[n]->spr->alive)
		{
            eEnemies[n]->spr->alive = true;
			eEnemies[n]->load(dDomes);
		}
		if(eEnemies[n]->spr->alive)
			eEnemies[n]->update(dDomes);
	}
}

void OVERWORLD::UpdateBullets()
{
	int n = 0, i = 0;
	bool hit = false;

	for(n = 0; n < MAX_BULLETS; n++)
	{			   
		if(bBullets[n]->sBullet->alive == true)
		{			
			bBullets[n]->update();
			// Moved out of range
			if(dist(bBullets[n]->start_x, bBullets[n]->start_y, bBullets[n]->sBullet->x, bBullets[n]->sBullet->y) >= bBullets[n]->range)			
				bBullets[n]->sBullet->alive = false;
			
			// Collision against Enemies
			for(i = 0; i < MAX_ENEMIES; i++)
			{
				if(bBullets[n]->sBullet->x > eEnemies[i]->x && bBullets[n]->sBullet->x < eEnemies[i]->x + eEnemies[i]->spr->width
					&& bBullets[n]->sBullet->y > eEnemies[i]->y && bBullets[n]->sBullet->y < eEnemies[i]->y + eEnemies[i]->spr->height)
					hit = true;
				if(bBullets[n]->sBullet->x + bBullets[n]->sBullet->width > eEnemies[i]->x && bBullets[n]->sBullet->x + bBullets[n]->sBullet->width < eEnemies[i]->x + eEnemies[i]->spr->width
					&& bBullets[n]->sBullet->y > eEnemies[i]->y && bBullets[n]->sBullet->y < eEnemies[i]->y + eEnemies[i]->spr->height)
					hit = true;
				if(bBullets[n]->sBullet->x > eEnemies[i]->x && bBullets[n]->sBullet->x < eEnemies[i]->x + eEnemies[i]->spr->width
					&& bBullets[n]->sBullet->y + bBullets[n]->sBullet->height > eEnemies[i]->y && bBullets[n]->sBullet->y + bBullets[n]->sBullet->height < eEnemies[i]->y + eEnemies[i]->spr->height)
					hit = true;
				if(bBullets[n]->sBullet->x + bBullets[n]->sBullet->width > eEnemies[i]->x && bBullets[n]->sBullet->x + bBullets[n]->sBullet->width < eEnemies[i]->x + eEnemies[i]->spr->width
					&& bBullets[n]->sBullet->y + bBullets[n]->sBullet->height > eEnemies[i]->y && bBullets[n]->sBullet->y + bBullets[n]->sBullet->height < eEnemies[i]->y + eEnemies[i]->spr->height)
					hit = true;

				if(hit == true)
				{
					bBullets[n]->sBullet->alive = false;
					eEnemies[i]->hit();
					hit = false;
				}
			}

			if(!bBullets[n]->sBullet->alive)
				destroy_bitmap(bBullets[n]->sBullet->bImage);


		}
	}

}

bool OVERWORLD::UpdateDomes()
{
	int n = 0;
	bool still_alive = false;

	for(n = 0; n < MAX_DOMES; n++)
	{
		if(dDomes[n]->spr->alive)
		{
			still_alive = true;
			dDomes[n]->update();
		}
	}

	return still_alive;
}


int OVERWORLD::dist(int x1, int y1, int x2, int y2)
{
	return sqrt(pow((x2 - x1), 2) + pow((y2 - y1), 2));
}


void OVERWORLD::smooth_shooting()
{
	//NULL for now
}

void OVERWORLD::quick_shooting()
{
	if(key[KEY_LEFT])
		unit->angle = 90;
	if(key[KEY_RIGHT])
		unit->angle = 270;
	if(key[KEY_UP])
		unit->angle = 180;
	if(key[KEY_DOWN])
		unit->angle = 0;
	if(key[KEY_LEFT] && key[KEY_UP])
		unit->angle = 135;
	if(key[KEY_LEFT] && key[KEY_DOWN])
		unit->angle = 45;
	if(key[KEY_RIGHT] && key[KEY_UP])
		unit->angle = 225;
	if(key[KEY_RIGHT] && key[KEY_DOWN])
		unit->angle = 315;
}

void OVERWORLD::movement()
{
	BLKSTR *test_block;
	int test_x = 0, test_y = 0;
	

	// Get movement direction
	unit->moving = NONE;
	if(key[KEY_LCONTROL])
	{
		if(backwards == true)
			unit->decrease_speed(0.2);
		if(unit->engine_speed < 0.4 || unit->engine > 0.4)
		{
			backwards = false;
			forwards = true;
		}
		if(forwards == true)
			unit->increase_speed(0.2);
	}		
	else if(key[KEY_ALT] || key[KEY_LSHIFT])
	{
		if(forwards == true)
			unit->decrease_speed(0.2);
		if(unit->engine_speed < 0.4 || unit->engine > 0.4)
		{
			forwards = false;
			backwards = true;
		}
		if(backwards == true)
			unit->increase_speed(0.2);
	}
	else
		unit->stabalize();

	if(unit->engine_speed != 0.0)
	{		
		if(backwards == true)
		{
			if(unit->alignment == VERTICAL)
			{
				if(unit->facing == DOWN)
					unit->moving = UP;
				else 
					unit->moving = DOWN;
			}
			else
			{
				if(unit->facing == RIGHT)
					unit->moving = LEFT;
				else 
					unit->moving = RIGHT;
			}
		}
		if(forwards == true)
		{
			if(unit->alignment == VERTICAL)
			{
				if(unit->facing == DOWN)
					unit->moving = DOWN;
				else 
					unit->moving = UP;
			}
			else
			{
				if(unit->facing == RIGHT)
					unit->moving = RIGHT;
				else 
					unit->moving = LEFT;
			}
		}
	}
	
	
	if(unit->moving == RIGHT)
		unit->x += int(unit->engine_speed);
	if(unit->moving == LEFT)
		unit->x -= int(unit->engine_speed);
	if(unit->moving == DOWN)
		unit->y += int(unit->engine_speed);
	if(unit->moving == UP)
		unit->y -= int(unit->engine_speed);
	
	//assume stamsp have been preset
	test_x = abs(unit->x + (unit->mobile->width/2) - x_stamp);
	test_y = abs(unit->y + (unit->mobile->height/2) - y_stamp);
	if(test_x >= TILE_W)
	{
		if(unit->moving == LEFT) block_x--;
		if(unit->moving == RIGHT) block_x++;
		//x_stamp = unit->x + (unit->mobile->width/2);
		x_stamp = block_x * 32 + (unit->mobile->width/2);		
	}
	if(test_y >= TILE_H)
	{
		if(unit->moving == UP) block_y--;
		if(unit->moving == DOWN) block_y++;		
		//allegro_message("%d", y_stamp);
		//y_stamp = unit->y + (unit->mobile->height/2);
		y_stamp = block_y * 32 + (unit->mobile->height/2);		
	}

	if(unit->moving == LEFT)
	{						
		test_block = MapGetBlock(block_x, block_y);
		if(!test_block->bl)
		{
			//allegro_message("%d %d", test_x, unit->x);
			if(test_x > TILE_W)
				unit->x += (test_x - TILE_W);
			else
				unit->x = block_x * TILE_W;
			turn_cart();
		}
	}
	else if(unit->moving == RIGHT)
	{			
		test_block = MapGetBlock(block_x, block_y);
		if(!test_block->br)
		{	
			if(test_x > TILE_W)
				unit->x = unit->x - (test_x - TILE_W); 
			else //Nasty pitfall
				unit->x = block_x * TILE_H;	
			
			turn_cart();
		}
	}
	if(unit->moving == UP)
	{								
		test_block = MapGetBlock(block_x, block_y);
		if(!test_block->tl)
		{
			if(test_y > TILE_H)
				unit->y += (test_y - TILE_H);
			else //Nasty pitfall
				unit->y = block_y * TILE_H;
			
			turn_cart();
		}
	}
	else if(unit->moving == DOWN)
	{						
		test_block = MapGetBlock(block_x, block_y);
		if(!test_block->tr)
		{	
			if(test_y > TILE_H)
				unit->y = unit->y - (test_y - TILE_H);
			else //Nasty pitfall
				unit->y = block_y * TILE_H;
						
			turn_cart();
		}
	}
	

	mapxoff = unit->x + unit->mobile->width/2 - GFX_W/2 + 10;
	mapyoff = unit->y + unit->mobile->height/2 - GFX_H/2 + 10;
}

/*if(key[KEY_ALT])
	{
		backwards = true;
		if(unit->alignment == VERTICAL)
		{
			if(unit->facing == DOWN)
				unit->moving = UP;
			else 
				unit->moving = DOWN;
		}
		else
		{
			if(unit->facing == RIGHT)
				unit->moving = LEFT;
			else 
				unit->moving = RIGHT;
		}		
	}*/



void OVERWORLD::turn_cart()
{
	BLKSTR *test_block;	
	test_block = MapGetBlock(block_x, block_y);
	
	if(unit->moving == LEFT)
	{
		if(test_block->tl) unit->facing = UP;
		else if(test_block->tr) unit->facing = DOWN;
		else unit->facing = RIGHT;
	}
	if(unit->moving == RIGHT)
	{
		if(test_block->tl) unit->facing = UP;
		else if(test_block->tr) unit->facing = DOWN;
		else unit->facing = LEFT;
	}
	if(unit->moving == UP)
	{
		if(test_block->bl) unit->facing = LEFT;
		else if(test_block->br) unit->facing = RIGHT;
		else unit->facing = DOWN;
	}
	if(unit->moving == DOWN)
	{		
		if(test_block->bl) unit->facing = LEFT;
		else if(test_block->br) 			unit->facing = RIGHT;		
		else unit->facing = UP;
	}

	if(backwards)
	{
		if(unit->facing == LEFT) unit->facing = RIGHT;
		else if(unit->facing == RIGHT) unit->facing = LEFT;
		else if(unit->facing == DOWN)	unit->facing = UP;				
		else if(unit->facing == UP) unit->facing = DOWN;
	}

	if(unit->facing == RIGHT || unit->facing == LEFT)
		unit->alignment = HORIZONTAL;
	if(unit->facing == UP || unit->facing == DOWN)
		unit->alignment = VERTICAL;
}

/*
void input2()
{
	bool MOVE_DOWN = false;
	bool MOVE_UP = false;
	bool MOVE_RIGHT = false;
	bool MOVE_LEFT = false;
	bool backwards = false;
	bool reset = false;
	int oldpx = unit->x;
	int oldpy = unit->y;
	BLKSTR *test_block;

	if(key[KEY_A])
		current_block = MapGetBlock(oldpx / mapblockwidth, oldpy / mapblockheight);

	// Move forwards
	if(key[KEY_LCONTROL])
	{
		if(unit->alignment == VERTICAL)
		{
			if(unit->facing == DOWN)
				MOVE_DOWN = true;
			else 
				MOVE_UP = true;
		}
		else
		{
			if(unit->facing == RIGHT)
				MOVE_RIGHT = true;
			else 
				MOVE_LEFT = true;
		}		
	}
	//move backwords
	else if(key[KEY_ALT])
	{
		backwards = true;
		if(unit->alignment == VERTICAL)
		{
			if(unit->facing == DOWN)
				MOVE_UP = true;
			else
				MOVE_DOWN = true;
		}
		else
		{
			if(unit->facing == RIGHT)
				MOVE_LEFT = true;
			else
				MOVE_RIGHT = true;			
		}
	}

	// Change directions ************************************
	// Worst programming yet!
	if(MOVE_LEFT == true && !current_block->bl)
	{		
		MOVE_LEFT = false;
		if(current_block->tl)
		{				
			if(!backwards) unit->facing = UP;				
			else unit->facing = DOWN;				
			MOVE_UP = true;
		}
		else if(current_block->tr)
		{	
			if(!backwards) unit->facing = DOWN;				
			else unit->facing = UP;
			MOVE_DOWN = true;
		}
		else
		{			
			if(!backwards) unit->facing = RIGHT;				
			else unit->facing = LEFT;							
			MOVE_RIGHT;
		}
	}

	else if(MOVE_RIGHT == true && !current_block->br)
	{	
		//allegro_message("turn right");
		MOVE_RIGHT = false;
		if(current_block->tl)
		{
			if(!backwards) unit->facing = UP;				
			else unit->facing = DOWN;											
			MOVE_UP = true;
		}
		else if(current_block->tr)
		{
			if(!backwards) unit->facing = DOWN;				
			else unit->facing = UP;														
			MOVE_DOWN = true;
		}
		else
		{
			if(!backwards) unit->facing = LEFT;				
			else unit->facing = RIGHT;																	
			MOVE_LEFT;
		}
	}

	else if(MOVE_UP == true && !current_block->tl)
	{
		MOVE_UP = false;
		if(current_block->bl)
		{
			if(!backwards) unit->facing = LEFT;				
			else unit->facing = RIGHT;														
			MOVE_LEFT = true;
		}
		else if(current_block->br)
		{
			if(!backwards) unit->facing = RIGHT;				
			else unit->facing = LEFT;						
			MOVE_RIGHT = true;
		}
		else
		{
			if(!backwards) unit->facing = DOWN;				
			else unit->facing = UP;						
			MOVE_DOWN;
		}
	}	
	else if(MOVE_DOWN == true && !current_block->tr)
	{
		MOVE_DOWN = false;
		if(current_block->bl)
		{			
			if(!backwards) unit->facing = LEFT;				
			else unit->facing = RIGHT;								
			MOVE_LEFT = true;
		}
		else if(current_block->br)
		{			
			if(!backwards) unit->facing = RIGHT;				
			else unit->facing = LEFT;											
			MOVE_RIGHT = true;
		}
		else
		{
			if(!backwards) unit->facing = UP;				
			else unit->facing = DOWN;											
			MOVE_UP;
		}
	}
	//************************************************************

		
		
	if(MOVE_RIGHT && unit->x < mapwidth * (mapblockwidth - 1))
		//&& current_block->br && unit->y % TILE_H == 0)
	{
		unit->x += unit->xspeed;
		unit->alignment = HORIZONTAL;
	}
	if(MOVE_LEFT && unit->x > 0)
		//&& current_block->bl && unit->y % TILE_H == 0)
	{
		unit->x -= unit->xspeed;
		unit->alignment = HORIZONTAL;
	}
	if(MOVE_UP && unit->y > 0)
		//&& current_block->tl && unit->x % TILE_W == 0)
	{
		unit->y -= unit->yspeed;
		unit->alignment = VERTICAL;
	}
	if(MOVE_DOWN && unit->y < mapheight * (mapblockheight - 1))
		//&& current_block->tr && unit->x % TILE_W == 0)
	{
		unit->y += unit->yspeed;
		unit->alignment = VERTICAL;
	}

	test_block = MapGetBlock(unit->x / mapblockwidth, unit->y / mapblockheight);
	if(test_block->trigger) reset = true;
	test_block = MapGetBlock((unit->x + TILE_W - 1) / mapblockwidth, unit->y / mapblockheight);
	if(test_block->trigger) reset = true;
	test_block = MapGetBlock(unit->x / mapblockwidth, (unit->y + TILE_H - 1)/ mapblockheight);
	if(test_block->trigger) reset = true;
	test_block = MapGetBlock((unit->x + TILE_W - 1) / mapblockwidth, (unit->y + TILE_H - 1) / mapblockheight);
	if(test_block->trigger) reset = true;

	if(reset == true)
	{	
		
		if(unit->x > oldpx)	while(unit->x % TILE_W != 0 && unit->x > oldpx) {unit->x--;}
		else				while(unit->x % TILE_W != 0 && unit->x < oldpx) {unit->x++;}
		
		if(unit->y > oldpy)	while(unit->y % TILE_H != 0 && unit->y > oldpy) {unit->y--;}
		else				while(unit->y % TILE_H != 0 && unit->y < oldpy) {unit->y++;}		
	}
	//current_block = MapGetBlock((unit->x + (unit->mobile->width/2)) / mapblockwidth, (unit->y + (unit->mobile->height/2)) / mapblockheight);
	if(MOVE_LEFT)	current_block = MapGetBlock((unit->x + TILE_W - 1) / mapblockwidth, unit->y / mapblockheight);		
	else if(MOVE_UP)current_block = MapGetBlock(unit->x / mapblockwidth, (unit->y + TILE_H - 1) / mapblockheight);
	else current_block = MapGetBlock(unit->x / mapblockwidth, unit->y / mapblockheight);
	
	
	

	//gone past a barrier
	//current_block = MapGetBlock(oldpx / mapblockwidth, oldpy / mapblockheight);
	/*if(oldpx / mapblockwidth != unit->x /mapblockwidth
		 || oldpy / mapblockheight != unit->y / mapblockheight 
		 || (oldpx + TILE_W) / mapblockwidth != (unit->x + TILE_W) / mapblockwidth
		 || (oldpy + TILE_H) / mapblockheight != (unit->y + TILE_H) / mapblockheight)
	{
		//allegro_message("%d %d", oldpy, unit->y);
		
		if(MOVE_UP)
		{
			current_block = MapGetBlock(oldpx / mapblockwidth, oldpy / mapblockheight);
			if(!current_block->tl) reset = true;
		}
		if(MOVE_DOWN)
		{
			current_block = MapGetBlock(oldpx / mapblockwidth, (oldpy + TILE_H) / mapblockheight);
			if(!current_block->tr) reset = true;
		}
		if(MOVE_RIGHT)			
		{
			//allegro_message("stop");
			current_block = MapGetBlock((oldpx + TILE_W) / mapblockwidth, oldpy / mapblockheight);
			if(!current_block->br) reset = true;			
		}
		if(MOVE_LEFT)
		{
			//allegro_message("stop");
			current_block = MapGetBlock(oldpx / mapblockwidth, oldpy / mapblockheight);
			if(!current_block->bl) reset = true;			
		}
		//if(MOVE_DOWN && !current_block->tr)
			//reset = true;

		//current_block = MapGetBlock(oldpx / mapblockwidth, oldpy / mapblockheight);
		

	}
	*/

			
	/*if(unit->y >= current_y + TILE_H || unit->y <= current_y - TILE_H || unit->y % TILE_H == 0)
	{
		
		current_y = unit->y;
		current_block = MapGetBlock((unit->x)/mapblockwidth, (unit->y) / mapblockheight);
		if(unit->y % TILE_H != 0)
		unit->y = ((unit->y / mapblockheight)) * mapblockheight;
	}*/
		
	
/*	mapxoff = unit->x + unit->mobile->width/2 - GFX_W/2 + 10;
	mapyoff = unit->y + unit->mobile->height/2 - GFX_H/2 + 10;

}*/


