#include "sprite.h"
#include "game.h"

SPRITE::SPRITE()
{
	dir = SOUTH;
	alive = false;
	x = 0; y = 0;
	width = 0; height = 0;
	xspeed = 0; yspeed = 0;
	xdelay = 0; ydelay = 0;
	xcount = 0; ycount = 0;
	xcurframe = 0; ycurframe = 0; maxframe = 0; animdir = 0;
	framecount = 0; framedelay = 0;
	bImage = NULL;

}

SPRITE::~SPRITE()
{
}

SPRITE::SPRITE(char *path, int width_dx, int height_dx, int maxframe_dx)
{
	dir = SOUTH;
	alive = false;
	x = 0; y = 0;
	width = width_dx; height = height_dx;
	xspeed = 0; yspeed = 0;
	xdelay = 0; ydelay = 0;
	xcount = 0; ycount = 0;
	xcurframe = 0; ycurframe = 0; maxframe = maxframe_dx; animdir = 0;
	framecount = 0; framedelay = 0;
	bFrames = load_bitmap(path, NULL);

}

void SPRITE::load(char *path, int width_dx, int height_dx, int maxframe_dx)
{
	
	dir = SOUTH;	
	alive = false;	
	x = 0; y = 0;
	width = width_dx; height = height_dx;	
	xspeed = 0; yspeed = 0;
	xdelay = 0; ydelay = 0;
	xcount = 0; ycount = 0;
	xcurframe = 0; ycurframe = 0; maxframe = maxframe_dx; animdir = 0;
	framecount = 0; framedelay = 0;
	
	bFrames = load_bitmap(path, NULL);
	bImage = create_bitmap(width, height);	
	get_frame();
}

void SPRITE::get_frame()
{		
	rectfill(bImage, 0, 0, bImage->w, bImage->h, makecol(255, 0, 255));
	masked_blit(bFrames, bImage, xcurframe * width, ycurframe * height, 0, 0, bImage->w, bImage->h);
}

void SPRITE::animate()
{
	if(abs(system_time - framecount) > framedelay)
	{
		xcurframe++;
		if(xcurframe == maxframe)
			xcurframe = 0;
		get_frame();
		framecount = system_time;
	}
}

 

