#ifndef _SPRITE_H_
#define _SPRITE_H_

#include "allegro.h"

enum DIRECTION{NONE, LEFT, RIGHT, DOWN, UP};
enum COMPASS{SOUTH, NORTH, WEST, EAST, SOUTHWEST, SOUTHEAST, NORTHWEST, NORTHEAST};

class SPRITE
{
public:
	COMPASS dir;
	bool alive;
	int x, y;
	int width, height;
	int xspeed, yspeed;
	int xdelay, ydelay;
	int xcount, ycount;
	int xcurframe, ycurframe, maxframe, animdir;
	int framecount, framedelay;
	BITMAP *bImage;
	BITMAP *bFrames;

	SPRITE();
	SPRITE(char *path, int width_dx, int height_dx, int maxframe_dx);
	~SPRITE();

	void load(char *path, int width_dx, int height_dx, int maxframe_dx);	
	void get_frame();
	void animate();

};

#endif /* End of _SPRITE_H_ */